<?php
/**
* This file specifices the show class.
*
* The show class is used to print elements of the board. There are several functions with which you can easily access every part of the board. This class is thought only for showing.
* @package classes
*/
class show {

	/**
	* A given database object.
	*/
  var $db_obj;
  
  /**
  * The constructor gets the database connection and handles it.
  *
  * @param database The database connection will be written in the variable <var>$db_obj</var>.
  */  
  function show(&$object) {
    $this->db_obj =& $object;
  }
  
  /**
  * Gives you all id's for the structures back.
  *
  * It selects every id from <i>nu_structure</i> and write it in an array.
  * @return array An array with all id's from <i>nu_structure</i> in it.
  */
  function structure_ids() {
    $res=$this->db_obj->sql("SELECT id FROM nu_structure");
    while ($pre = mysql_fetch_array($res)) {
      $ids[] = $pre[id];
    }
    return $ids;
  }
  
	/**
	* Returns the name of the structure. 
	*
	* It selects the name from <i>nu_structure</i> for the given <var>$id</var>. 
	* @param int A id from a structure. You can use <i>structure_ids()</i> to get all id's.
	* @return string You get the name from the structure as an String back.
	*/
	function structure($id) {
    $res=$this->db_obj->sql("SELECT name FROM nu_structure WHERE id='$id'");
    $pre = mysql_fetch_array($res);
    return $pre[name];
	}
  
  /**
  * Returns all id's from the substructures.
  *
  * Gives you an overview, which substructure are there.
  * @return array Returns an array with all substructure id's in it.
  */
  function substructure_ids() {
    $res=$this->db_obj->sql("SELECT id FROM nu_substructure");
    while ($pre = mysql_fetch_array($res)) {
      $ids[] = $pre[id];
    }
    return $ids;
  }
  
  /**
  * Gives you the substructure name. 
  *
  * Gives the name of a substructure.
  * @param int The id of the substructure.
  * @return string An string with the name of the substructure is returned.
  */
	function substructure($id) {
    $res=$this->db_obj->sql("SELECT name FROM nu_substructure WHERE id='$id';");
    $pre = mysql_fetch_array($res);
    return $pre[name];
	}
  
  /**
  * Gives you an overview of all substructures belonging to an given structure.
  *
  * Gives you the id and the name of all substructures belonging to an specific structure.
  * @param int The id of the structure.
  * @return array An array with the id and the name of all substructures from the given structure is returned.
  */
	function substructures($sid) {
    $res=$this->db_obj->sql("SELECT id,name FROM nu_substructure WHERE sid='$sid';");
    while ($pre = mysql_fetch_array($res)) {
      //$subs[] = array("id"=>$pre[id], "name"=>$pre[name]);
      $subs[$pre[id]] = $pre[name];
    }
    return $subs;
	}
	
  /**
  * Gives you information on a specific thread.
  *
  * Gives you uid, post_time, subject, views about a specific thread.
  * @param int A thread id.
  * @return array Returns a big array with [post_time, subject, views, replies, nick].
  */
	function thread($id) {
  
    $res=$this->db_obj->sql("SELECT uid,post_time,subject,views FROM nu_threads WHERE id='$id';");
    $pre = mysql_fetch_array($res);
    
    $pres=$this->db_obj->sql("SELECT count(id) FROM nu_posts WHERE tid='$pre[id]';");
    $replies = mysql_result($pres,0) - 1;
      
    $ures=$this->db_obj->sql("SELECT nick FROM nu_users WHERE id='$pre[uid]';");
    $nick = mysql_result($ures,0);
    
    $thread = array("post_time"=>$pre[post_time], "subject"=>$pre[subject], "views"=>$pre[views], "replies"=>$replies, "nick"=>$nick);
    
    return $thread;
    
	}
  
  /**
  * Gives you information about all threads in a substructure.
  *
  * Gives you id, uid, post_time, subjec, views for all threads from a specific substructure.
  * @param int The substructure id.
  * @return array Returns a two-dimensional array [][id,post_time,subject,views,replies,nick] with all thread information in a given substructure.
  */  
  function threads($ssid, $ls=0, $ll=0) {
    
    if ($ll == 0) $ll = $this->count_threads($ssid);
    
    $res=$this->db_obj->sql("SELECT id,uid,post_time,subject,views FROM nu_threads WHERE ssid='$ssid' ORDER BY post_time DESC LIMIT $ls, $ll");
    
    while ($pre = mysql_fetch_array($res)) {
      
      $pres=$this->db_obj->sql("SELECT count(id) FROM nu_posts WHERE tid='$pre[id]';");
      $replies = mysql_result($pres,0) - 1;
      
      $ures=$this->db_obj->sql("SELECT nick FROM nu_users WHERE id='$pre[uid]';");
            $nick = mysql_result($ures,0);
      
      $threads[] = array("id"=>$pre[id], "post_time"=>$pre[post_time], "subject"=>$pre[subject], "views"=>$pre[views], "replies"=>$replies, "nick"=>$nick);
    
    }
    
    return $threads;
    
	}
	
	/**
	* Count all threads in a given substructure.
	*
	* @param int A substructure id.
	* @return int Returns the number of the threads.
	*/	
	function count_threads($ssid) {
	
		$res=$this->db_obj->sql("SELECT count(id) FROM nu_threads WHERE ssid='$ssid'");
		$threads = mysql_result($res,0);
	
		return $threads;
	
	}
  
  /**
	* Count all posts in a given thread.
	*
	* @param int A thread id.
	* @return int Returns the number of the posts.
	*/	
	function count_posts($tid) {
	
		$res=$this->db_obj->sql("SELECT count(id) FROM nu_posts WHERE tid='$tid'");
		$threads = mysql_result($res,0);
	
		return $threads;
	
	}
  
  /**
  * Gives you all information on a specific post.
  *
  * Gives you the uid, post_time and the text.
  * @param int The id of a post.
  * @return array Returns an array [post_time,text,nick] from a specific post.
  */  
	function post($id) {
  
    $res=$this->db_obj->sql("SELECT uid,post_time,text FROM nu_posts WHERE id='$id'");
    $pre = mysql_fetch_array($res);
  
    $ures=$this->db_obj->sql("SELECT nick FROM nu_users WHERE id='$pre[uid]'");
    $nick = mysql_result($ures,0);
  
    $post = array("post_time"=>$pre[post_time], "text"=>$pre[text], "nick"=>$nick);
    
    return $post;
    
	}
  
  /**
  * Gives you all posts for a given thread id.
  *
  * Gives you the id, uid, post_time and test for all posts belonging to a thread.
  * @param int A thread id.
  * @param int A LIMIT start value
  * @param int A LIMIT length value
  * @return array Returns a two-dimensional array [][id,post_time,text,nick] with all information from the posts belonging to a specific thread.
  */  
  function posts($tid, $ls=0, $ll=0) {
  
    if ($ll == 0) $ll = $this->count_posts($tid);
  
    $res=$this->db_obj->sql("SELECT id,uid,post_time,text FROM nu_posts WHERE tid='$tid' LIMIT $ls, $ll");
     
    while ($pre = mysql_fetch_array($res)) {
    
      $ures=$this->db_obj->sql("SELECT nick FROM nu_users WHERE id='$pre[uid]'");
      $nick = mysql_result($ures,0);
  
      $posts[] = array("id"=>$pre[id], "uid"=> $pre[uid], "post_time"=>$pre[post_time], "text"=>$pre[text], "nick"=>$nick);
    
    }
    
    return $posts;
    
	}
	
	/**
	* Checks if the given post id is the first post in a thread.
	*
	* Simply checks if the given post id is the first one from a thread and returns true or false.
	* @param int A post id.
	* @return string Returns true or false.
	*/
	function first_post($pid,$tid) {
		$res = $this->db_obj->sql("SELECT id FROM nu_posts WHERE tid='$tid' ORDER BY post_time ASC LIMIT 0,1");
		if(mysql_result($res,0) == $pid) {
			return true;
		} else {
			return false;
		}
	}	
  
  /**
  * Gives you the last post from a given substructure.
  *
  * Gives you the pid, uid, post_time, tid, subject and page from the last posted thread in a substructure.
  * @param int A substructure id.
  * @return string Returns an array [pid,uid,post_time,tid,subject,page].
  */  
  function last_post($ssid) {
  
		$res=$this->db_obj->sql("SELECT nu_posts.id as pid, nu_posts.uid, nu_posts.post_time, nu_posts.tid, nu_threads.subject FROM nu_posts INNER JOIN nu_threads ON nu_posts.tid = nu_threads.id AND nu_threads.ssid = '$ssid' ORDER BY nu_posts.post_time DESC LIMIT 0,1");
    $pre = mysql_fetch_assoc($res);
    if($this->count_posts($pre[tid]) > $this->ppp()) {
    	for($i=0; $i < ($this->count_posts($pre[tid]) / $this->ppp()); $i++) {
    		$page = $i*$this->ppp();	
    	}
    	$tempArray = array( "page" => $page);
      $pre = array_merge ($pre, $tempArray);
    }
    
    return $pre;
    
	}
	
	/**
	* Formats an timestamp with an format from the database.
	*
	* Gets the format template from the database and format the given timestamp.
	* @param int A timestamp.
	* @return string The formatted time.
	*/	
	function format_date($timestamp) {
	
		$pre = $this->db_obj->sql("SELECT time_format FROM nu_preferences WHERE id='1'");
		$format = mysql_result($pre,0);
		
		return date($format,$timestamp);
		
	}
  
  /**
	* Increment the view number for a given thread.
	*
	* @param int A thread id.
	*/
  function increment_views($tid) {
  
		$this->db_obj->sql("UPDATE nu_threads SET views = views+1 WHERE id = '$tid'");	
		
	}
  
  /**
	* Returns the ssid for a given tid.
	*
	* @param int A thread id.
	* @return int The specific substructure id.
	*/
  function tid_ssid($tid) {
  
		$pre = $this->db_obj->sql("SELECT ssid FROM nu_threads WHERE id='$tid'");	
		
    return mysql_result($pre,0);
    
	}
  
  /**
	* Returns the name of the board.
	*
	* Fetches the name from <i>nu_preferences</i>.
	* @return string The name of the board.
	*/
  function name() {
  
		$pre = $this->db_obj->sql("SELECT name FROM nu_preferences WHERE id='1'");	
		
    return mysql_result($pre,0);
    
	}
  
  /**
	* Returns the number of posts per page.
	*
	* Fetches the number of posts per page from <i>nu_preferences</i>.
	* @return int The number of posts per page.
	*/
  function ppp() {
  
		$pre = $this->db_obj->sql("SELECT ppp FROM nu_preferences WHERE id='1'");	
		
    return mysql_result($pre,0);
    
	}
  
	/**
	* Returns the number of threads per page.
	*
	* Fetches the number of threads per page from <i>nu_preferences</i>.
	* @return int The number of threads per page.
	*/
  function tpp() {
  
		$pre = $this->db_obj->sql("SELECT tpp FROM nu_preferences WHERE id='1'");	
		
    return mysql_result($pre,0);
    
	}
  
  /**
  * Checks if there is already a structure with the name <var>$name</var>.
  *
  * @param string The name of a structure.
  * @return int Returns 0 or 1.
  */  
  function structure_exists($name) {
  
  $return = false;
  
  if(is_array($this->structure_ids())) {
  	foreach ($this->structure_ids() as $sid) {
  		if($this->structure($sid) == $name) {
  			$return = true;
			}
		}
	}

	return $return;
  
  }
  
  /**
  * Gives you all Pages from a given Thread.
  *
  * @param int The thread id.
  * @param int The new start limit.
  * @param string The label which will be printed right beforce the pages. Standard is \"Pages:\".
  * @param string With \"yes\" you get the pages without any missing link. Standard is \"no\".
  * @return string The complete pages with the given options.
  */  
  function show_pages_posts($tid,$p,$label="Pages:",$all="no") {
  
  	$replies = $this->count_posts($tid);

		$number = ceil($replies/$this->ppp());

		$return = $label;

		$x = 0;

		for($j=0; $j < $number; $j++) {
			$m = $j*$this->ppp();
			$page = $j+1;
  		if (($p == $m) && ($all != "yes")) {
    		$return .= " ". $page ." ";
  		} else {
    		$return .= " <a href=\"posts.php?tid=$tid&p=$m\">$page</a> ";
  		}
		}
		
		return $return;
		
	}
	
	/**
  * Gives you all Pages from a given substructure.
  *
  * @param int The substructure id.
  * @param int The new start limit.
  * @param string The label which will be printed right beforce the pages. Standard is \"Pages:\".
  * @return string The complete pages with the given options.
  */  
	function show_pages_threads($ssid,$p,$label="Pages:") {
  
  	$threads = $this->count_threads($ssid);

		$number = ceil($threads/$this->tpp());

		echo $label;

		$x = 0;

		for($j=0; $j < $number; $j++) {
			$m = $j*$this->tpp();
			$page = $j+1;
  		if ($p == $m) {
    		echo " ". $page ." ";
  		} else {
    		echo " <a href=\"$php_self?ssid=$ssid&p=$m\">$page</a> ";
  		}
		}
	}
    
}
?>