<?php
/**
* The registration formular as well as the insert into the database.
*
* All actions are redirected here. So the handling of errors are here.
* @package nuboard
*/

session_start();

/**
* All classes are included and the objects are created.
*/
include("inc/classes.inc.php");

/**
* Check if user has a cookie set and set session if yes
*/
if((!$user_data->user_logged_in()) && ($_COOKIE["userid"] != "")) {
	$_SESSION["userid"] = $_COOKIE["userid"];
	$user_data->increment_visits($_SESSION["userid"]);
}

/**
* set last_online if session exists
*/
if($user_data->user_logged_in()) {
	$user_data->set_last_online($_SESSION["userid"]);
}

/**
* make $_POST and $_GET variables accessible through their names
*/
	foreach ($_POST as $key => $var) {
  	$$key = $var;
	}
	
	foreach ($_GET as $key => $var) {
  	$$key = $var;
	}
	
	
/**
* Registration Typo and checks...
*/
if($go == "Register") {

/**
* Error handling
*/

	$error = 0;
	$new_user =& new user($db);

	/**
  * Nick empty?
  */
	if($nickname == "") {
		$message[] = "You forgot your nickname.";
		//echo "<div id=\"error\">You forgot your nickname.</div>";
		$error += 1;
		
	/**
  * Nick already in use
  */
	} elseif(is_array($new_user->user_exists($nickname))) {
		$message[] = "The nickname <b>'$nickname'</b> is already in use.";
		//echo "<div id=\"error\">The nickname <b>'$nickname'</b> is already in use.</div>";
		$error += 1;
	}

	/**
	* eMail empty?
	*/
	if($email == "") {
		$message[] = "You must enter a eMail address.";
		//echo "<div id=\"error\">You must enter a eMail address.</div>";
		$error += 1;
		
	/**
	* eMail valid?
	*/
	} elseif(!eregi("^[A-Z0-9._%-]+@[A-Z0-9._%-]+\.[A-Z]{2,4}$", $email)) {
		$message[] = "<b>'$email'</b> is not a valid email address.";
	 	//echo "<div id=\"error\"><b>'$email'</b> is not a valid email address.</div>";
	 	$error += 1;
	 	
  /**
  * eMail already in use
  */
	} elseif($new_user->email_exists($email)) {
		$message[] = "The eMail <b>'$email'</b> is already registered.";
		//echo "<div id=\"error\">The eMail <b>'$email'</b> is already registered.</div>";
		$error += 1;
	}
	
	/**
	* Password long engough?
	*/
	if(strlen($password) < 8) {
		$message[] = "Your password must be at least 8 chars long.";
		//echo "<div id=\"error\">Your password must be at least 8 chars long.</div>";
		$error += 1;
		
		/**
		* Password typo
		*/
	} elseif(md5($password) != md5($repeat_password)) {
		$message[] = "You didn't typed your password correctly.";
		//echo "<div id=\"error\">You didn't typed your password correctly.</div>";
		$error += 1;
	}
	
	if(strlen($signature) > 256) {
		$message[] = "Your signature can only have 256 chars maximum.";
		//echo "<div id=\"error\">Your signature can only have 256 chars maximum.</div>";
		$error += 1;
	}	
	
	if(!is_array($message)) {
		$password = md5($password);
		$time = time();
		$db->sql("INSERT INTO nu_users (christian_name, family_name, nick, email, password, icq, homepage, signature, since, status) VALUES ('$christian_name','$family_name','$nickname','$email','$password','$icq','$homepage','$signature',$time,1)");
		$create = 1;
	}
} 
	
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en"<?php if(!empty($create)) echo " style=\"height:95%\""; ?>>
<head>
<meta name="author" content="Axel Benjamins and Georg Renz" />
<meta name="copyright" content="2005" />
<title>Registration</title>
<?php
if(!empty($create)) {
	echo "<meta http-equiv=\"refresh\" content=\"3; URL=board.php\">";
}
?>
<link rel="stylesheet" type="text/css" href="inc/main.inc.css">
</head>
<body<?php if(!empty($create)) echo " style=\"text-align:center; height:95%; vertical-align:middle; width:99%\""; ?>>
<div class="board" style="border: 0px solid #FFFFFF; width: 550px">
<?php

if(empty($create)) {

	if(is_array($message)) {
		echo "<div class=\"confirmation\">\n<br />\n";
		echo "<div id=\"error\">\n";
		foreach ($message as $print) {
			echo $print ."<br />\n";
		}
		echo "</div><br />\n</div>\n<br /><br />\n";
	}

	$reg =& new form();
	echo "<div class=\"registration\">";
	echo "<h2>Registration</h2>";
	echo $reg->open_form("register",$PHP_SELF,"POST");
	echo "<span class=\"inscription\">Christian name: </span>";
	echo $reg->short_input("christian_name",48,$christian_name,"class=\"optional\"");
	echo "<span class=\"inscription\">Family name: </span>";
	echo $reg->short_input("family_name",48,$family_name,"class=\"optional\"");
	echo "<span class=\"inscription\">Nickname: </span>";
	echo $reg->short_input("nickname",48,$nickname,"class=\"required\"");
	echo "<span class=\"inscription\">eMail: </span>";
	echo $reg->short_input("email",64,$email,"class=\"required\"");
	echo "<span class=\"inscription\">Password: </span>";
	echo $reg->short_input("password",32,"","class=\"required\"","password");
	echo "<span class=\"inscription\">Repeat password: </span>";
	echo $reg->short_input("repeat_password",32,"","class=\"required\"","password");
	echo "<span class=\"inscription\">ICQ #UIN: </span>";
	echo $reg->short_input("icq",14,$icq,"class=\"optional\"");
	echo "<span class=\"inscription\">Homepage: </span>";
	echo $reg->short_input("homepage",64,$homepage,"class=\"optional\"");
	echo "<span class=\"inscription\">Signature: </span>";
	echo $reg->long_input("signature",$signature);
	echo "<br />\n";
	echo $reg->button("go","Register");
	echo $reg->close_form();
	echo "</div>";
} else {
		echo "<div class=\"confirmation\">\n<br />\n";
		echo "<b>User successfully registered.</b><br />You will be redirected in 3 seconds. If your browser doesn't support redirecting, <a href=\"board.php\">click here</a>.";
		echo "<br /><br />\n</div>\n\n";
}
?>
</div>
</body>
</html>